local function ChangeSectorBrightness(line, mobj, sector)
	-- Get needed vars from linedef
	local brightnesspercentage = line.frontside.textureoffset/FRACUNIT -- X Offset
	local brightnessthreshold = line.frontside.rowoffset/FRACUNIT -- Y Offset
	local flagusetag = false
	if (line.flags & ML_EFFECT2) then flagusetag = true end -- No midtexture skew
	-- Change Sector Brightness

    --print(brightnesspercentage.." "..brightnessthreshold..(flagusetag and " true " or " false ")..line.tag)
	for currentsector in sectors.iterate do
		if (flagusetag and currentsector.tag ~= line.tag) then continue end
		if (currentsector.lightlevel >= brightnessthreshold) then continue end
		currentsector.lightlevel = FixedMul(FRACUNIT*$, FixedDiv(FRACUNIT*brightnesspercentage, FRACUNIT*100))/FRACUNIT
	end
end

addHook("LinedefExecute", ChangeSectorBrightness, "BRIGHTNESSPERCENTAGE")
