if portal2gels_loaded then return end

local ACCGEL_SPEEDBOOST = FRACUNIT
local ACCGEL_ACCELBOOST = 2*FRACUNIT

local REPGEL_JUMPSPEED = 40*FRACUNIT
local REPGEL_MOMZ = 3*REPGEL_JUMPSPEED/4

-- Why not boost stack it? :D
-- Only works if booststack was loaded before map
local have_booststack = booststack ~= nil

if have_booststack then
    booststack.registerBoostType("accelgelboost", {
        stackable = true,
        stacktics = false,

        speedboost = "1",
        accelboost = "2",
    })
end

local k_speedboost = k_speedboost
local k_accelboost = k_accelboost

-- Acceleration gel. Gives you shitton of boost :3
-- (forgot its called "propulsion" or something like that, too lazy to rename now)
--
-- Intended to be used on intangible FOF's with continuous trigger
-- If ML_NOCLIMB is set, won't spawn goo effects
addHook("LinedefExecute", function(line, mo, sec)
    if not (mo.player or P_IsObjectOnGround(mo)) then return end

    if mo.player.speed > FixedMul(20*FRACUNIT, mapobjectscale) then
        if mo.goosfxtimer == nil then mo.goosfxtimer = 0 end

        if mo.goosfxtimer > 0 then
            mo.goosfxtimer = mo.goosfxtimer - 1
        else
            mo.goosfxtimer = TICRATE/8

            local y = nil

            local z = sec.ceilingheight

            if sec.c_slope then
                z = P_GetZAt(sec.c_slope, mo.x, mo.y)
            end

            local s = P_SpawnMobj(mo.x, mo.y, z, MT_SPLISH)
            s.colorized = true
            s.color = SKINCOLOR_ORANGE

            S_StartSound(mo, sfx_ghit)
        end
    end

    if have_booststack and booststack.running then
        booststack.doBoost(mo, "accelgelboost", 1)
    else
        local ks = mo.player.kartstuff

        ks[k_speedboost] = max($, ACCGEL_SPEEDBOOST)
        ks[k_accelboost] = max($, ACCGEL_ACCELBOOST)
    end
end, "ACCGEL")

-- Repulsion gel. Not much different from springs
--
-- Intended to be used for regular sector (or maybe solid FOF), with an
-- "every time" trigger
-- If "Block Enemies" flag is set, will ignore floor touch and speed checks, intended to be used
-- for FOF triggers ~~or workarounds for janky slope behaviour~~
addHook("LinedefExecute", function(line, mo, sec)
	if P_IsObjectOnGround(mo) or (line.flags & ML_BLOCKMONSTERS) then
        local speed = FixedHypot(mo.momx, mo.momy)
        local linelength = FixedHypot(line.dx, line.dy)

        if (FixedDiv(speed, mapobjectscale) >= linelength) or (mo.eflags & MFE_JUSTHITFLOOR) or (line.flags & ML_BLOCKMONSTERS) then
            -- Change player velocity
            if line.flags & ML_NOCLIMB then
                if line.flags & ML_EFFECT2 then
                    -- If we have this flag, set player direction AND speed
                    mo.momx = line.dx
                    mo.momy = line.dy
                else
                    -- Only change direction, keep speed
                    local speed = FixedHypot(mo.momx, mo.momy)

                    mo.momx = FixedMul(speed, FixedDiv(line.dx, linelength))
                    mo.momy = FixedMul(speed, FixedDiv(line.dy, linelength))
                end
            end

            if mo.flags2 & MF2_OBJECTFLIP then
                mo.momz = -line.frontside.textureoffset
            else
                mo.momz = line.frontside.textureoffset
            end

            S_StartSound(mo, sfx_s263)
        end
    end
end, "REPGEL")

rawset(_G, "portal2gels_loaded", true)